package org.colcon.burocrat.api.client;

import java.util.Map;

import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.ICommand;
import org.colcon.burocrat.api.model.IItem;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.ui.HeaderPanel;

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Widget;

public interface IClient 
{
	public IWidgets widgets();
	
	public IPageImpl[] getPageImpls();
	public IItemPageImpl[] getItemPageImpls();
	public IFieldTypeImpl[] getFieldTypeImpls();
	
	public IPageImpl getPageImpl(String name);
	public IItemPageImpl getItemPageImpl(String name);
	public IFieldTypeImpl getFieldTypeImpl(String name);
	
	public IClient addHeader(HeaderPanel h);
	public HeaderPanel getHeader();
	
	public boolean isLoggedIn();
	
	public void login(String userId, String password);
	public void logout();
	
	public String getUserId();
	public String getUserPassword();
	public IItem getUser();
	
	public String getURL();
	public String getPath();
	
	public Map<IArg, String> getArgs();
	public void setArgs(Map<IArg, String> map);
	
	public void refresh();
	public void show(String url);
	public void show(Widget widget);
	
	public void sendRequest(ICommand command, AsyncCallback<IResponse> callback);
}
