package org.colcon.burocrat.api.model;

import java.util.Map;

public interface IParser 
{
	public Map<IArg, String> stringsToArgs(Map<String, String> map);
	public Map<String, String> argsToStrings(Map<IArg, String> args);
	
	public Map<IArg, String> parseArgs(String str);
	public String composeArgs(Map<IArg, String> map);
	
	public IItem parseItem(String str);
	public String composeItem(IItem item);
	
	public ICommand parseCommand(String str);
	public String composeCommand(ICommand command);
	
	public IResponse parseResponse(String str);
	public String composeResponse(IResponse response);
	
	public ILink parseLink(String str);
	public String composeLink(ILink link);
	
	public IItem[] parseItemArray(String str);
	public String composeItemArray(IItem... array);
	
	public String[] parseArgArray(String str);
	public String composeArgArray(String... array);
	
	public String[] parsePath(String path);
	public String composePath(String... array);
	
	public String pathToParent(String path);
	public String pathToId(String path);
	
	public Map<String, String> parse(String str);
	public String compose(Map<String, String> map);
}
