package org.colcon.burocrat.client;

import org.colcon.burocrat.api.client.IClient;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.RootPanel;

/**
 * 
 * This is where instances of the client are instantiated
 * 
 * @author Dan Vegeto
 *
 */
public class Burocrat implements EntryPoint
{
	/**
	 * Create a remote service proxy to talk to the server-side service implementation.
	 */
	private final BurocratServiceAsync service = GWT.create(BurocratService.class);
	
	/**
	 * Create an Burocrat client that spans the gap between the browser GUI and the RPC service. 
	 */
	private final IClient client = new Client("Burocrat", PageImpl.values(), ItemPageImpl.values(), FieldTypeImpl.values(), new Widgets(), RootPanel.get(), service);

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad() 
	{
		client.refresh();
	}	
}
