package org.colcon.burocrat.client;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.client.IItemPageImpl;
import org.colcon.burocrat.api.model.IItem;
import org.colcon.burocrat.client.item.ContainerPage;
import org.colcon.burocrat.client.item.ItemPage;

/**
 * These are implementations of item pages for item types with the same name
 * 
 * @author Dan Vegeto
 *
 */
public enum ItemPageImpl implements IItemPageImpl
{
	ITEM
	{
		public ItemPage buildItemPage(IClient client, IItem item) 
		{
			return new ItemPage(client, item);
		}
	},
	
	CONTAINER
	{
		public ItemPage buildItemPage(IClient client, IItem item) 
		{
			return new ContainerPage(client, item);
		}
	}
	
	;
	
	public static IItemPageImpl[] getValues()
	{
		return (IItemPageImpl[])values();
	}
}
