package org.colcon.burocrat.client;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.client.IFieldTypeImpl;
import org.colcon.burocrat.api.client.IItemPageImpl;
import org.colcon.burocrat.api.client.IWidgets;
import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.IFieldType;
import org.colcon.burocrat.api.model.IItem;
import org.colcon.burocrat.api.model.IItemType;
import org.colcon.burocrat.client.item.ItemPage;
import org.colcon.burocrat.client.ui.FooterPanel;
import org.colcon.burocrat.client.ui.HeaderPanel;

import com.google.gwt.user.client.ui.HTML;

/**
 * This is a widget factory that builds custom GUI components
 * 
 * @author Dan Vegeto
 *
 */
public class Widgets implements IWidgets
{
	public HTML loading()
	{
		return new HTML("<img src=\"img/loading.gif\">");
	}
	
	public HTML error()
	{
		return new HTML("oops, something went wrong (try refreshing)");
	}
	
	public HeaderPanel buildHeader(IClient client)
	{
		return new HeaderPanel(client);
	}
	
	public FooterPanel buildFooter(IClient client)
	{
		return new FooterPanel(client);
	}
	
	public ItemPage buildItemPage(IClient client, IItem item)
	{
		IItemType type = item.getType();
		
		IItemPageImpl itemPanelImpl = null;
		
		if(type != null)
			itemPanelImpl = client.getItemPageImpl(type.name());
		
		if(itemPanelImpl == null)
			itemPanelImpl = ItemPageImpl.ITEM;
		
		return itemPanelImpl.buildItemPage(client, item);
	}
	
	public BurocratField buildField(IClient client, IArg arg)
	{
		IFieldType fieldType = arg.fieldType();
		IFieldTypeImpl fieldTypeImpl = client.getFieldTypeImpl(fieldType.name());
		
		return fieldTypeImpl.buildField(client, arg);
	}
}
