package org.colcon.burocrat.client.form;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.IChoice;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.BurocratField;
import org.colcon.burocrat.client.CSS;

import com.google.gwt.user.client.ui.ListBox;

/**
 * 
 * A drop-down list for selecting from a set of options
 * 
 * @author Dan Vegeto
 *
 */
public class ListBoxField extends BurocratField 
{
	private ListBox listBox;
	
	public ListBoxField(IClient client, IArg arg) 
	{
		super(client, arg);
	}
	
	public void init(IResponse data) 
	{
		listBox = new ListBox();
		listBox.setStyleName(CSS.TEXT.getStyle());
		listBox.addItem("");
		
		IChoice[] choices = getArg().choices();
		
		if(choices != null)
			for(IChoice choice : choices)
				listBox.addItem(choice.name());
		
		if(getChangeHandler() != null)
			listBox.addChangeHandler(getChangeHandler());
		
		add(listBox);
	}

	public String getValue() 
	{
		int i = listBox.getSelectedIndex();
		
		if(i == -1)
			return null;
		
		return listBox.getValue(i);
	}

	public void setValue(String value) 
	{
		for(int i = 0; i < listBox.getItemCount(); i++)
			if(listBox.getValue(i).equalsIgnoreCase(value))
				listBox.setSelectedIndex(i);
	}
}
