package org.colcon.burocrat.client.form;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.BurocratField;
import org.colcon.burocrat.client.CSS;

import com.google.gwt.user.client.ui.TextArea;

/**
 * A BurocratField for entering large amounts of text
 * 
 * @author Dan Vegeto
 *
 */
public class TextAreaField extends BurocratField 
{
	private TextArea textArea;
	
	public TextAreaField(IClient client, IArg arg) 
	{
		super(client, arg);
	}

	public void init(IResponse data) 
	{
		textArea = new TextArea();
		textArea.setStyleName(CSS.TEXT.getStyle());
		
		if(getChangeHandler() != null)
			textArea.addChangeHandler(getChangeHandler());
		
		add(textArea);
	}
	
	public String getValue() 
	{
		return textArea.getText();
	}

	public void setValue(String value) 
	{
		textArea.setText(value);
	}
}
