package org.colcon.burocrat.client.form;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.BurocratField;
import org.colcon.burocrat.client.CSS;

import com.google.gwt.user.client.ui.TextBox;

/**
 * A simple text input field
 * 
 * @author Dan Vegeto
 *
 */
public class TextBoxField extends BurocratField 
{
	private TextBox textBox;
	
	public TextBoxField(IClient client, IArg arg) 
	{
		super(client, arg);
	}

	public void init(IResponse data) 
	{
		textBox = new TextBox();
		textBox.setStyleName(CSS.TEXT.getStyle());
		
		if(getChangeHandler() != null)
			textBox.addChangeHandler(getChangeHandler());
		
		add(textBox);
	}
	
	public String getValue() 
	{
		return textBox.getText();
	}

	public void setValue(String value) 
	{
		textBox.setText(value);
	}
}
