package org.colcon.burocrat.client.ui;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.ICommand;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.CSS;

import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.DockLayoutPanel;

/**
 * 
 * The superclass for all pages
 * 
 * @author Dan Vegeto
 *
 */
public class BurocratPage extends DockLayoutPanel
{
	private static final int
	
		HEADER_HEIGHT = 50;//,
		//FOOTER_HEIGHT = 35;
	
	private IClient client;
	
	public BurocratPage(IClient client) 
	{
		super(Unit.PX);
		
		this.client = client;
	}
	
	public IClient getClient()
	{
		return client;
	}
	
	public ICommand getRequest()
	{
		return null;
	}
	
	public void refresh()
	{
		clear();
		onLoad();
	}
	
	protected void onLoad()
	{
		super.onLoad();
		
		if(getRequest() == null)
			init(null);
		else
		{
			add(getClient().widgets().loading());
		
			getClient().sendRequest(getRequest(), new AsyncCallback<IResponse>()
			{
				public void onFailure(Throwable caught) 
				{
					clear();
					add(getClient().widgets().error());
				}
	
				public void onSuccess(IResponse result) 
				{
					clear();
					init(result);
				}
			});
		}
	}
	
	public void init(IResponse data)
	{
		setHeight((Window.getClientHeight()) + "px");
		
		addNorth(getClient().widgets().buildHeader(getClient()), HEADER_HEIGHT);
		//addSouth(getClient().widgets().buildFooter(getClient()), FOOTER_HEIGHT);
		
		setStyleName(CSS.PAGE.getStyle());
	}
}
