package org.colcon.burocrat.model;

import java.util.HashMap;
import java.util.Map;

import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.IArgValue;

/**
 * 
 * A single key-value pair, consisting of an argument key and a string value
 * 
 * @author Dan Vegeto
 *
 */
public class ArgValue implements IArgValue 
{
	private IArg arg;
	private String value;
	
	public ArgValue(IArg arg, String value)
	{
		this.arg = arg;
		this.value = value;
	}
	
	public IArg getArg() 
	{
		return arg;
	}

	public String getValue() 
	{
		return value;
	}
	
	public String toString()
	{
		Map<IArg, String> map = new HashMap<IArg, String>();
		
		map.put(arg, value);
		
		return Model.instance.parser().composeArgs(map);
	}
}
