package org.colcon.burocrat.model;

import org.colcon.burocrat.api.model.IResponseType;

/**
 * These values are different output codes for 
 * the command line interface. For example,
 * if the server response starts with "FAILED",
 * that means the command failed to execute.
 * 
 * @author Dan Vegeto
 *
 */
public enum ResponseType implements IResponseType
{
	DID_NOTHING,
	MESSAGE,
	
	SUCCEEDED,
	FAILED,
	
	AUTHENTICATION_ERROR,
	MISSING_POWER,
	
	ITEM
	{
		public Object parseObject(String str) 
		{
			return Model.instance.parser().parseItem(str);
		}
	},
	
	ITEM_LIST
	{
		public Object parseObject(String str) 
		{
			return Model.instance.parser().parseItemArray(str);
		}
	}
	
	;

	public Object parseObject(String message) 
	{
		return message;
	}
}
