package org.colcon.burocrat.server;

import org.colcon.burocrat.api.model.IItem;
import org.colcon.burocrat.api.server.INotifier;
import org.colcon.burocrat.model.Arg;

/**
 * 
 * This class is responsible for sending user notifications for news
 * 
 * @author Dan Vegeto
 *
 */
public class Notifier implements INotifier 
{
	public void notify(String notified, String text)
	{
		IItem item = Server.instance.get(notified);
		
		if(item == null)
			return;
		
		String email = item.getArg(Arg.EMAIL);
		
		if(email != null)
			Server.instance.emailer().send(email, "Notification for #" + notified, text);
	}
}
