package org.colcon.burocrat.app.client;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.app.model.AppModel;
import org.colcon.burocrat.client.BurocratService;
import org.colcon.burocrat.client.BurocratServiceAsync;
import org.colcon.burocrat.client.Client;
import org.colcon.burocrat.client.PageImpl;
import org.colcon.burocrat.client.Widgets;
import org.colcon.burocrat.client.item.ItemPanelImpl;
import org.colcon.burocrat.client.form.FieldTypeImpl;
import org.colcon.burocrat.model.Model;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.RootPanel;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class BurocratApp implements EntryPoint 
{
	/**
	 * Create a remote service proxy to talk to the server-side service implementation.
	 */
	private final BurocratServiceAsync service = GWT.create(BurocratService.class);
	
	/**
	 * Create an MRCWS client that spans the gap between the browser GUI and the RPC service. 
	 */
	private final IClient client = new Client
	(
		"Burocrat App", 
		
		PageImpl.values(), 
		ItemPanelImpl.values(), 
		FieldTypeImpl.values(),
		
		new Widgets(),
		RootPanel.get(), 
		service
	);

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad() 
	{
		Model.instance = AppModel.instance;
		
		client.refresh();
	}	
}
