package org.colcon.burocrat.app.model;

import org.colcon.burocrat.api.model.IItem;
import org.colcon.burocrat.api.model.IModel;
import org.colcon.burocrat.api.utils.ArrayUtil;
import org.colcon.burocrat.model.Arg;
import org.colcon.burocrat.model.Cmd;
import org.colcon.burocrat.model.Constants;
import org.colcon.burocrat.model.Item;
import org.colcon.burocrat.model.ItemType;
import org.colcon.burocrat.model.Model;
import org.colcon.burocrat.model.Parser;

public class AppModel
{
	public static final String version = "0.1.0";
	
	public static IModel instance =
			
		new Model
		(
			ArrayUtil.append(Arg.getValues(), AppArg.getValues()), 
			ArrayUtil.append(Cmd.getValues(), AppCmd.getValues()),
			ArrayUtil.append(ItemType.getValues(), AppItemType.getValues()),
			
			new Parser(), 
			
			new IItem[]
			{
				new Item(ItemType.METADATA.withArgs(Constants.ROOT, version)), 
				new Item(ItemType.CONTAINER.withArgs(Constants.ROOT, ItemType.LINK.plural())), 
				new Item(ItemType.CONTAINER.withArgs(Constants.ROOT, ItemType.NEWS.plural()))
			}
		);
}
