package org.colcon.burocrat.app.server;

import java.util.Map;

import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.ICmd;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.api.server.ICmdImpl;
import org.colcon.burocrat.model.Model;
import org.colcon.burocrat.model.Response;


public enum AppCmdImpl implements ICmdImpl 
{
	TEST
	{
		public IResponse execute(String agent, Map<IArg, String> args) 
		{
			return new Response(true, "the test was successful");
		}
	}
	
	;
	
	public ICmd getCmd()
	{
		return Model.instance.getCmd(name());
	}
	
	public String getNews (String agent, Map<IArg, String> args)
	{
		return getCmd().getNews(agent, args);
	}
	
	public IResponse validate(String agent, Map<IArg, String> args)
	{
		return new Response(true);
	}
	
	public abstract IResponse execute(String agent, Map<IArg, String> args);
	
	public static ICmdImpl[] getValues()
	{
		return (ICmdImpl[])values();
	}
}
