package org.colcon.burocrat.app.server;

import org.colcon.burocrat.api.server.IServer;
import org.colcon.burocrat.api.utils.ArrayUtil;
import org.colcon.burocrat.server.ArgImpl;
import org.colcon.burocrat.server.Authenticator;
import org.colcon.burocrat.server.CmdImpl;
import org.colcon.burocrat.server.Database;
import org.colcon.burocrat.server.Emailer;
import org.colcon.burocrat.server.Encryptor;
import org.colcon.burocrat.server.ItemTypeImpl;
import org.colcon.burocrat.server.Notifier;
import org.colcon.burocrat.server.Server;

public class AppServer 
{
	public static IServer instance = new Server
	(
		ArrayUtil.append(ArgImpl.getValues(), AppArgImpl.getValues()),
		ArrayUtil.append(CmdImpl.getValues(), AppCmdImpl.getValues()), 
		ArrayUtil.append(ItemTypeImpl.values(), AppItemTypeImpl.getValues()),
		
		new Database(), 
		new Authenticator(),
		new Encryptor(), 
		new Emailer(), 
		new Notifier()
	);
}
