package org.colcon.burocrat.app.server;

import javax.servlet.ServletException;

import org.colcon.burocrat.api.model.ICommand;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.app.model.AppModel;
import org.colcon.burocrat.client.BurocratService;
import org.colcon.burocrat.model.Model;
import org.colcon.burocrat.server.Server;


import com.google.gwt.user.server.rpc.RemoteServiceServlet;

/**
 * The server side implementation of the RPC service.
 */
@SuppressWarnings("serial")
public class BurocratServiceImpl extends RemoteServiceServlet implements BurocratService 
{
	public void init() throws ServletException
	{
		super.init();
		
		Model.instance = AppModel.instance;
		Server.instance = AppServer.instance;
		
		Server.instance.init();
	}
	
	public String sendRequest(String id, String password, String command)
	{
		ICommand commandObj = Model.instance.parser().parseCommand(command);
		IResponse result = Server.instance.execute(id, commandObj);
		
		return result.toString();
	}
}
